ZeyosRestClient::ZeyosRestConnection Class Reference

class for Zeyos.com REST connections; returns ZeyosRestClient::ZeyosRestClient objects More...

Inheritance diagram for ZeyosRestClient::ZeyosRestConnection:
[legend]

## Public Member Functions

| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the ZeyosRestConnection object More...
hash< auto > | getConstructorOptions (hash< auto > options)
| gets options for the constructor
*hash< auto > | getDefaultOptions ()
| returns default options
hash< auto > | getOptions ()
| gets options More...
string | getType ()
| returns `"zeyosrest"`

## Public Attributes

const | ZeyosOptions
| ZeyosRestConnection object connection options.

## Protected Member Functions

ZeyosRestClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns a ZeyosRestClient::ZeyosRestClient object More...

## Detailed Description

class for Zeyos.com REST connections; returns ZeyosRestClient::ZeyosRestClient objects

supports the following options:

- `"identifier"` (optional): the zeyos.com identifier
- `"appsecret"` (mandatory): the zeyos.com appsecret
- `"connect_timeout"`: connection timeout to use in milliseconds
- `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
- `"data"`: see RestClient::RestClient::DataSerializationOptions for possible values when used with the null REST schema validator; the default is `"auto"`
- `"error_passthru"`: if True then HTTP status codes indicating errors will not cause an `HTTP-CLIENT-RECEIVE-ERROR` exception to be raised, rather such responses will be passed through to the caller like any other response
- `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
- `"max_redirects"`: maximum redirects to support
- `"proxy"`: proxy URL to use
- `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
- `"swagger"`: the path to a Swagger 2.0 REST schema file for runtime API validation (see the Swagger module)
- `"timeout"`: transfer timeout to use in milliseconds

Note
  additionally supports the following runtime option in getImpl():
  - `"validator"`: an AbstractRestSchemaValidator object for REST message validation (if present, overrides any REST schema validation option provided as a connection option)

See also
  ZeyosRestClient::constructor() for more information on the above options

## Member Function Documentation

## constructor()

ZeyosRestClient::ZeyosRestConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the ZeyosRestConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  ZEYOSRESTCONNECTION-ERROR | missing needed option for Zeyos authentication

## getImpl()

ZeyosRestClient ZeyosRestClient::ZeyosRestConnection::getImpl | ( | bool | connect = `True`,
|  | *hash< auto > | rtopts
| ) |  |

protected

returns a ZeyosRestClient::ZeyosRestClient object

Parameters

  connect | if True, then the connection is returned already connected
  rtopts | this connection type does not accept any runtime options, so this parameter is ignored

Returns
  a ZeyosRestClient object

## getOptions()

hash<auto> ZeyosRestClient::ZeyosRestConnection::getOptions | ( |  | ) |

gets options

Returns
  returns a hash with the following supported options:
  - `"connect_timeout"`: connection timeout to use in milliseconds
  - `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
  - `"data"`: see RestClient::RestClient::DataSerializationOptions for possible values; the default is `"json"`
  - `"error_passthru"`: if True then HTTP status codes indicating errors will not cause an `HTTP-CLIENT-RECEIVE-ERROR` exception to be raised, rather such responses will be passed through to the caller like any other response
  - `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
  - `"max_redirects"`: maximum redirects to support
  - `"proxy"`: proxy URL to use
  - `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
  - `"timeout"`: transfer timeout to use in milliseconds

See also
  ZeyosRestClient::constructor() for more information on the above options